
#include "PrimaryGeneratorAction.hh"
#include "G4ParticleTable.hh"
#include "G4ParticleDefinition.hh"
#include "G4ParticleGun.hh"

PrimaryGeneratorAction::PrimaryGeneratorAction()
{
  fParticleGun = new G4ParticleGun(1);

  G4ParticleTable* particleTable = G4ParticleTable::GetParticleTable();
  G4ParticleDefinition* particle = particleTable->FindParticle("geantino");
  fParticleGun->SetParticleDefinition(particle);

  G4double energy(100*MeV);
  G4ThreeVector momentum = G4ThreeVector(0, 0, 1);
  G4ThreeVector position = G4ThreeVector(0, 0, 0);

  fParticleGun->SetParticleEnergy(energy);
  fParticleGun->SetParticleMomentumDirection(momentum);
  fParticleGun->SetParticlePosition(position);
}

PrimaryGeneratorAction::~PrimaryGeneratorAction()
{
  delete fParticleGun;
}

void PrimaryGeneratorAction::GeneratePrimaries(G4Event* anEvent)
{
  fParticleGun->GeneratePrimaryVertex(anEvent);
}
