#ifndef ACTIONBASICMESSENGER_HH
#define ACTIONBASICMESSENGER_HH

#include "G4UImessenger.hh"

class G4UIdirectory;
class G4UIcmdWithABool;
class G4UIcmdWithAString;
class G4UIcmdWithADoubleAndUnit;
class PrimaryGeneratorActionBasic;

// singleton pattern
class ActionBasicMessenger : public G4UImessenger
{
public:
  static ActionBasicMessenger* GetInstance();
  virtual ~ActionBasicMessenger();

  void Register(PrimaryGeneratorActionBasic* primaryGeneratorActionBasic);

  void SetNewValue(G4UIcommand*, G4String);
  G4String GetRunName(){return fRunName;}
  G4bool GetUseTree(){return fUseTree;}
  G4String GetTreeName(){return fTreeName;}
  G4String GetTreeTitle(){return fTreeTitle;}

protected:
  static ActionBasicMessenger* fActionBasicMessenger;

  G4String fRunName;
  G4bool fUseTree;
  G4String fTreeName;
  G4String fTreeTitle;
  PrimaryGeneratorActionBasic* fPrimaryGeneratorActionBasic;

  G4UIdirectory* fActionDir;
  G4UIcmdWithAString* fRunNameCmd;
  G4UIcmdWithABool* fUseTreeCmd;
  G4UIcmdWithAString* fTreeNameCmd;
  G4UIcmdWithAString* fTreeTitleCmd;
  G4UIcmdWithAString* fBeamTypeCmd;
  G4UIcmdWithADoubleAndUnit* fBeamEnergyCmd;
  G4UIcmdWithADoubleAndUnit* fBeamSigmaCmd;
  G4UIcmdWithADoubleAndUnit* fBeamThetaCmd;

private: // hidden
  ActionBasicMessenger();
  ActionBasicMessenger(const ActionBasicMessenger& actionMessenger);
  ActionBasicMessenger& operator=(const ActionBasicMessenger& actionMessenger);
};

#endif

