#ifndef PRIMARYGENERATORACTIONBASIC_HH
#define PRIMARYGENERATORACTIONBASIC_HH

#include "G4VUserPrimaryGeneratorAction.hh"
#include "G4String.hh"

class G4ParticleGun;
class TRandom3;
class ActionBasicMessenger;

class PrimaryGeneratorActionBasic : public G4VUserPrimaryGeneratorAction
{
public:
  PrimaryGeneratorActionBasic(G4int seed = 128);
  virtual ~PrimaryGeneratorActionBasic();

  bool SetBeamType(G4String beamType);
  void GeneratePrimaries(G4Event*);

  virtual void AccumulateBeamData(G4Event* anEvent);

  bool SetBeamEnergy(G4double energy);
  bool SetBeamSigma(G4double sigma);
  bool SetBeamTheta(G4double theta);

  void BeamTypeMonoEnergy(G4Event* anEvent);
  void BeamTypeMonoEnergyRandTheta(G4Event* anEvent);
  void BeamTypeMonoEnergyRandMomentum(G4Event* anEvent);
  void BeamTypeMonoEnergyRandMomentumRandPosition(G4Event* anEvent);
  void BeamTypeGausEnergy(G4Event* anEvent);
  void BeamTypeGausEnergyRandTheta(G4Event* anEvent);
  void BeamTypeExpEnergyRandMomentum(G4Event* anEvent);
  void BeamTypeCs137(G4Event* anEvent);
  void BeamTypeCo60(G4Event* anEvent);
  void BeamTypeY88(G4Event* anEvent);
  void BeamTypeBeamInducedGamma(G4Event* anEvent);

protected:
  G4ParticleGun* fParticleGun;

  TRandom3* fRandom;
  G4double fBeamEnergy;
  G4double fBeamSigma;
  G4double fBeamTheta;

  void (PrimaryGeneratorActionBasic::*beamFunctionPtr)(G4Event*);

  ActionBasicMessenger* fActionBasicMessenger;
};

#endif


