
#include "EventActionBasic.hh"
#include "ActionBasicMessenger.hh"

#include "G4Event.hh"

#include "TAnalysisInterface.hh"

#include "TTree.h"
#include "TDirectory.h"

EventActionBasic::EventActionBasic(TAnalysisInterface* analysisInterface)
  : fAnalysisInterface(analysisInterface)
{
  fActionBasicMessenger = ActionBasicMessenger::GetInstance();
}

EventActionBasic::~EventActionBasic()
{;}

void EventActionBasic::BeginOfEventAction(const G4Event* anEvent)
{
  if((anEvent->GetEventID()+1) % 1000 == 0){
  //  {
    G4cout << "\r Event:" << anEvent->GetEventID()+1 << std::flush;
    //    G4cout << "Event:" << anEvent->GetEventID()+1 << std::endl;
  }

  fAnalysisInterface->ClearBuffer();
}

void EventActionBasic::EndOfEventAction(const G4Event* /* anEvent */)
{
  if(fActionBasicMessenger->GetUseTree()){
    TTree* tree;
    gDirectory->GetObject(fActionBasicMessenger->GetTreeName(), tree);
    tree->Fill();
  }

  fAnalysisInterface->ProcessOneEvent();
}  
