#ifndef TANALYSISBULK_HH
#define TANALYSISBULK_HH

#include "TObject.h"
#include "TVector3.h"

#include <vector>
#include <string>

#include "TAnalysisInterface.hh"
#include "TSimulationDataScintillator.hh"

class TFile;
class TTree;
class TH1;
class TSimulationParameterGlobal;

class TAnalysisBulk : public TAnalysisInterface
{
public:
  TAnalysisBulk();
  virtual ~TAnalysisBulk();
  
  virtual int CreateAndAnalyzeExpData();

  virtual int Initialize();
  virtual int CreateBranch(TTree* tree);
  virtual int AddParameters(TFile* file);
  virtual int ReadParameters(TFile* file);
  virtual int PrintParameters();
  virtual int CreateHist();

  virtual int ClearBuffer();
  virtual int ProcessOneEvent();

protected:
  // parameters
  TSimulationParameterGlobal* fSimParaGlobal;

private:
  TH1 *fHQ, *fHT, *fHTQ;

  ClassDef(TAnalysisBulk, 1)
};

#endif
