#ifndef TANALYSISGAMMADETECTOR_HH
#define TANALYSISGAMMADETECTOR_HH

#include "TObject.h"

#include <map>

#include "TAnalysisInterface.hh"
#include "TSimulationDataScintillator.hh"

class TFile;
class TTree;
class TH1;
class TSimulationParameterGlobal;

class TAnalysisGammaDetector : public TAnalysisInterface
{
public:
  TAnalysisGammaDetector();
  virtual ~TAnalysisGammaDetector();
  
  virtual int CreateAndAnalyzeExpData();

  virtual int Initialize();
  virtual int CreateBranch(TTree* tree);
  virtual int AddParameters(TFile* file);
  virtual int ReadParameters(TFile* file);
  virtual int PrintParameters();
  virtual int CreateHist();

  virtual int ClearBuffer();
  virtual int ProcessOneEvent();

protected:
  TH1* fHQ1;
  TH1* fHQ10;
  TH1* fHIDQ1;
  TH1* fHIDQ10;

  //  parameters
  TSimulationParameterGlobal* fSimParaGlobal;

  Double_t fEnergyResolution;

  // temporary container
  std::map<Int_t, Double_t> fQ;

  ClassDef(TAnalysisGammaDetector, 1)
};

#endif
