#ifndef TANALYSISINTERFACE_HH
#define TANALYSISINTERFACE_HH

#include "TObject.h"

#include <string>
#include <deque>

class TFile;
class TTree;

class TAnalysisInterface
{
public:
  TAnalysisInterface();
  virtual ~TAnalysisInterface();
  
  // used only when re-analysis tree
  int book(std::string rootfile);
  int SetOutputFileName(std::string rootfile);
  int StartAnalysis(Long64_t numberOfEntries = -1);
  virtual int CreateAndAnalyzeExpData(); // not yet implemented generary

  // called in RunActionBasic
  virtual int Initialize() = 0;
  virtual int CreateBranch(TTree* tree) = 0;
  virtual int AddParameters(TFile* file) = 0;
  virtual int ReadParameters(TFile* file) = 0;
  virtual int PrintParameters() = 0;
  virtual int CreateHist() = 0;

  // called in EventActionBasic
  virtual int ClearBuffer() = 0;
  virtual int ProcessOneEvent() = 0;

protected:
  std::deque<std::string> fROOTFileNameArray;
  std::string fOutputFileName;

  TFile* fFileSim;
  TFile* fFileExp;

  Long64_t fNumberOfEntries;
  Int_t fInitial;

  ClassDef(TAnalysisInterface, 1)
};

#endif
