#ifndef BEAMPIPECONSTRUCTION_HH
#define BEAMPIPECONSTRUCTION_HH

#include "G4VUserDetectorConstruction.hh"
#include "G4ThreeVector.hh"

class DetectorConstruction;
class G4LogicalVolume;
class G4Material;

class BeamPipeConstruction : public G4VUserDetectorConstruction
{
  friend class DetectorConstruction;
  
public:
  BeamPipeConstruction();
  virtual ~BeamPipeConstruction();

  G4VPhysicalVolume* Construct();
  virtual G4LogicalVolume* ConstructSub();

  G4ThreeVector GetBeamPipeSize(){return fBeamPipeSize;}

protected:
  G4ThreeVector fBeamPipeSize;

  G4LogicalVolume* fLogicBeamPipe;
  G4LogicalVolume* fLogicWorld;

  G4Material* fBeamPipeMotherMaterial;
  G4Material* fBeamPipeMaterial;
  G4Material* fPbShieldMaterial;
  G4Material* fWorldMaterial;
};

#endif

