#ifndef NEUTRONWINDOWCONSTRUCTION_HH
#define NEUTRONWINDOWCONSTRUCTION_HH

#include "G4VUserDetectorConstruction.hh"
#include "G4ThreeVector.hh"

class G4LogicalVolume;
class G4Material;
class DetectorConstruction;

class NeutronWindowConstruction : public G4VUserDetectorConstruction
{
  friend class DetectorConstruction;
  
public:
  NeutronWindowConstruction();
  virtual ~NeutronWindowConstruction();

  G4VPhysicalVolume* Construct();
  virtual G4LogicalVolume* ConstructSub();

  G4ThreeVector GetNeutronWindowSize(){return fNeutronWindowSize;}

protected:
  G4ThreeVector fNeutronWindowSize;

  G4LogicalVolume* fLogicNeutronWindow;
  G4LogicalVolume* fLogicWorld;

  G4Material* fNeutronWindowMaterial;
  G4Material* fWorldMaterial;
};

#endif

