
#include "MenatePhysics.hh"

#include "G4ParticleDefinition.hh"
#include "G4ProcessManager.hh"

#include "menate_R.hh"

MenatePhysics::MenatePhysics(G4int ver)
  : G4VPhysicsConstructor("MenatePhysics"), verbose(ver), 
    wasActivated(false)
{
  if(verbose > 1) { 
    G4cout << "### MenatePhysics: " << GetPhysicsName() 
	   << G4endl; 
  }
}

MenatePhysics::MenatePhysics(const G4String&,
    G4int ver, G4bool, const G4String&)
  : G4VPhysicsConstructor("MenatePhysics"), verbose(ver), 
    wasActivated(false)
{
  if(verbose > 1) { 
    G4cout << "### MenatePhysics: " << GetPhysicsName() 
	   << G4endl; 
  }
}

MenatePhysics::~MenatePhysics()
{}

void MenatePhysics::ConstructParticle()
{}

void MenatePhysics::ConstructProcess()
{
  if(wasActivated) { return; }
  wasActivated = true;

  //  G4cout << "MenatePhysics::ConstructProcess" << G4endl;

  theParticleIterator->reset();
  while( (*theParticleIterator)() ){
    G4ParticleDefinition* particle = theParticleIterator->value();
    G4ProcessManager* pmanager = particle->GetProcessManager();
    G4String particleName = particle->GetParticleName();
 
    if(particleName == "neutron"){
      //      G4String NeutronProcessName = "menate_neutron";
      G4String NeutronProcessName = "NeutronInelastic";
      menate_R* theMenate = new menate_R(NeutronProcessName);
      //      theMenate->SetMeanFreePathCalcMethod("ORIGINAL");
      theMenate->SetMeanFreePathCalcMethod("carbon_inel_only");
      pmanager->AddDiscreteProcess(theMenate);
    }
  }
}
